#include "EngineInfo.h"

namespace chessy
{
    namespace info
    {
        using namespace std;

        short   version[3] = {1, 0, 0};
        string  versionString =
            to_string(version[0]) + "." +
            to_string(version[1]) + "." +
            to_string(version[2]);
        string  longName = "Chessy Chess Engine";
        string  shortName = "Chessy";

        string  welcomeText = "Welcome to "s + shortName +
            " (Version " + versionString + ").";

        string  helpText =
            "This is the Chessy Chess Engine.\n\n"
            "It uses the Universal Chess Interface (UCI).\n\n"
            "Have fun playing!";
    }
}

